'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PhantomRenderer = undefined;

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _rsvp = require('rsvp');

var _rsvp2 = _interopRequireDefault(_rsvp);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _child_process = require('child_process');

var _child_process2 = _interopRequireDefault(_child_process);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _phantomjsPrebuilt = require('phantomjs-prebuilt');

var _phantomjsPrebuilt2 = _interopRequireDefault(_phantomjsPrebuilt);

var _request = require('request');

var _request2 = _interopRequireDefault(_request);

var _url = require('url');

var _renderer = require('../../renderer');

var _renderer2 = _interopRequireDefault(_renderer);

var _sentinels = require('./utils/sentinels');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaults = _lodash2.default.defaults;
var Promise = _rsvp2.default.Promise,
    denodeify = _rsvp2.default.denodeify;


var DEFAULT_PORT = 8180;
var PHANTOM_SCRIPT = _path2.default.join(__dirname, '-main.js');

var PhantomRenderer = exports.PhantomRenderer = function (_Renderer) {
  (0, _inherits3.default)(PhantomRenderer, _Renderer);
  (0, _createClass3.default)(PhantomRenderer, [{
    key: 'url',
    get: function get() {
      return 'http://localhost:' + this.port;
    }
  }], [{
    key: 'DEFAULT_PORT',
    get: function get() {
      return this._DEFAULT_PORT || DEFAULT_PORT;
    },
    set: function set(value) {
      return this._DEFAULT_PORT = value;
    }
  }, {
    key: 'request',
    get: function get() {
      return denodeify(_request2.default);
    }
  }]);

  function PhantomRenderer() {
    var attrs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    (0, _classCallCheck3.default)(this, PhantomRenderer);

    var _this = (0, _possibleConstructorReturn3.default)(this, (PhantomRenderer.__proto__ || (0, _getPrototypeOf2.default)(PhantomRenderer)).call(this, attrs));

    _this.port = _this.port || _this.constructor.DEFAULT_PORT;
    return _this;
  }

  (0, _createClass3.default)(PhantomRenderer, [{
    key: 'boot',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
        var _this2 = this;

        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                (0, _get3.default)(PhantomRenderer.prototype.__proto__ || (0, _getPrototypeOf2.default)(PhantomRenderer.prototype), 'boot', this).call(this);

                _context2.prev = 1;
                _context2.next = 4;
                return new Promise(function () {
                  var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(resolve, reject) {
                    return _regenerator2.default.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            _this2.once('didBoot', resolve);
                            setTimeout(function () {
                              reject(new Error('timed out'));
                            }, 5000);

                            _this2.presenter.stdin.write(_this2.port + '\n', 'utf8');

                          case 3:
                          case 'end':
                            return _context.stop();
                        }
                      }
                    }, _callee, _this2);
                  }));

                  return function (_x2, _x3) {
                    return _ref2.apply(this, arguments);
                  };
                }());

              case 4:

                this._killStream('stdin');
                this.didBoot = true;
                _context2.next = 13;
                break;

              case 8:
                _context2.prev = 8;
                _context2.t0 = _context2['catch'](1);

                this.didBoot = false;
                this.trigger('error', _context2.t0);

                throw _context2.t0;

              case 13:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this, [[1, 8]]);
      }));

      function boot() {
        return _ref.apply(this, arguments);
      }

      return boot;
    }()
  }, {
    key: 'shutdown',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
        var phantom;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                phantom = this.phantom;


                if (phantom !== null && phantom !== undefined) {
                  ['stdout', 'stderr'].forEach(this._killStream.bind(this));

                  phantom.kill();
                  this._phantom = null;
                }

              case 2:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function shutdown() {
        return _ref3.apply(this, arguments);
      }

      return shutdown;
    }()
  }, {
    key: 'ping',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                return _context4.abrupt('return', this._makeRequest('ping'));

              case 1:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function ping() {
        return _ref4.apply(this, arguments);
      }

      return ping;
    }()
  }, {
    key: 'loadPage',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(page) {
        var _this3 = this;

        var json = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        var url, html;
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                url = json.url, html = json.html;


                json.id = page.id;

                if (html === undefined || html === null) {
                  json.url = new _url.URL(url || page.id);
                }

                this._makeRequest('loadPage', {
                  method: 'POST',
                  body: json
                });

                return _context6.abrupt('return', new Promise(function () {
                  var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(resolve, reject) {
                    return _regenerator2.default.wrap(function _callee5$(_context5) {
                      while (1) {
                        switch (_context5.prev = _context5.next) {
                          case 0:
                            page.once('didLoad', resolve);
                            setTimeout(function () {
                              reject(new Error('load timed out'));
                            }, 5000);

                          case 2:
                          case 'end':
                            return _context5.stop();
                        }
                      }
                    }, _callee5, _this3);
                  }));

                  return function (_x6, _x7) {
                    return _ref6.apply(this, arguments);
                  };
                }()));

              case 5:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function loadPage(_x4) {
        return _ref5.apply(this, arguments);
      }

      return loadPage;
    }()
  }, {
    key: 'renderPage',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(page) {
        var json = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        return _regenerator2.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                json.id = page.id;

                return _context7.abrupt('return', this._makeRequest('renderPage', {
                  method: 'POST',
                  body: json
                }));

              case 2:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function renderPage(_x8) {
        return _ref7.apply(this, arguments);
      }

      return renderPage;
    }()
  }, {
    key: 'unloadPage',
    value: function () {
      var _ref8 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8(id) {
        var json = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        return _regenerator2.default.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                return _context8.abrupt('return', this._makeRequest('unloadPage', {
                  method: 'POST',
                  body: json
                }));

              case 1:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function unloadPage(_x10) {
        return _ref8.apply(this, arguments);
      }

      return unloadPage;
    }()
  }, {
    key: '_makeRequest',
    value: function () {
      var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee9(path) {
        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        var url, response, _ref10, headers, statusCode, body;

        return _regenerator2.default.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                url = this.url + '/' + path;
                response = this.constructor.request(url, defaults(options, {
                  json: true
                }));
                _context9.next = 4;
                return response;

              case 4:
                _ref10 = _context9.sent;
                headers = _ref10.headers;
                statusCode = _ref10.statusCode;
                body = _ref10.body;


                this.isBooted = headers['Server'] === 'render-vendor';

                _context9.t0 = true;
                _context9.next = _context9.t0 === statusCode >= 200 ? 12 : _context9.t0 === statusCode < 300 ? 12 : _context9.t0 === statusCode < 400 ? 17 : 18;
                break;

              case 12:
                _context9.t1 = headers['Content-Type'];
                _context9.next = _context9.t1 === 'application/json' ? 15 : 16;
                break;

              case 15:
                return _context9.abrupt('return', JSON.parse(body));

              case 16:
                return _context9.abrupt('return', body);

              case 17:
                return _context9.abrupt('return', headers['Location']);

              case 18:
                throw new this.constructor.Error.UnexpectedResponse(response);

              case 19:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function _makeRequest(_x12) {
        return _ref9.apply(this, arguments);
      }

      return _makeRequest;
    }()
  }, {
    key: '_spawnPhantom',
    value: function _spawnPhantom() {
      var _ref11 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this,
          _ref11$bin = _ref11.bin,
          bin = _ref11$bin === undefined ? _phantomjsPrebuilt2.default.path : _ref11$bin,
          _ref11$binArgs = _ref11.binArgs,
          binArgs = _ref11$binArgs === undefined ? [] : _ref11$binArgs;

      var phantom = _child_process2.default.spawn(bin, [].concat((0, _toConsumableArray3.default)(binArgs), [PHANTOM_SCRIPT]));

      phantom.stdout.on('data', this._handleStdOut.bind(this));
      phantom.stderr.on('data', this._handleStdErr.bind(this));
      phantom.on('exit', this.destroy.bind(this));

      return phantom;
    }
  }, {
    key: '_handleStdOut',
    value: function _handleStdOut(buffer) {
      var message = buffer.toString() || 'could not read buffer';
      var isSentinel = (0, _values2.default)(_sentinels.SENTINELS).some(function (sentinel) {
        return message.startsWith(sentinel + '\n');
      });

      if (isSentinel) {
        var sentinelIndex = message.indexOf('\n');
        var sentinel = message.slice(0, sentinelIndex);
        var data = message.slice(sentinelIndex).trim();

        switch (sentinel) {
          case _sentinels.SENTINELS.didBoot:
            data = data === 'true';
            break;

          case _sentinels.SENTINELS.pageLoaded:
          case _sentinels.SENTINELS.pageLoading:
            data = JSON.parse(data);
            break;
        }

        this.emit(sentinel, data);
      } else {
        this.emit('message', message);
      }
    }
  }, {
    key: '_handleStdErr',
    value: function _handleStdErr(buffer) {
      this.emit('error', buffer.toString() || 'could not read buffer');
    }
  }, {
    key: '_killStream',
    value: function _killStream(streamName) {
      var stream = this.presenter[streamName];

      if (stream && stream.end && typeof stream.end === 'function') {
        stream.end();
      }
    }
  }, {
    key: 'phantom',
    get: function get() {
      var phantom = this._phantom;

      if (phantom === undefined) {
        this._phantom = this._spawnPhantom();
        phantom = this._phantom;
      }

      return phantom;
    }
  }]);
  return PhantomRenderer;
}(_renderer2.default);

Phantom.Error = function (_Error) {
  (0, _inherits3.default)(PhantomError, _Error);

  function PhantomError() {
    (0, _classCallCheck3.default)(this, PhantomError);
    return (0, _possibleConstructorReturn3.default)(this, (PhantomError.__proto__ || (0, _getPrototypeOf2.default)(PhantomError)).apply(this, arguments));
  }

  return PhantomError;
}(Error);
Phantom.Error.UnexpectedResponse = function (_Phantom$Error) {
  (0, _inherits3.default)(UnexpectedResponseError, _Phantom$Error);

  function UnexpectedResponseError() {
    (0, _classCallCheck3.default)(this, UnexpectedResponseError);
    return (0, _possibleConstructorReturn3.default)(this, (UnexpectedResponseError.__proto__ || (0, _getPrototypeOf2.default)(UnexpectedResponseError)).apply(this, arguments));
  }

  (0, _createClass3.default)(UnexpectedResponseError, [{
    key: 'toString',
    value: function toString() {
      var _message = this.message,
          statusCode = _message.statusCode,
          body = _message.body,
          url = _message.request.url;


      return this.name + ': HTTP' + statusCode + ' - ' + url + ':\n' + body;
    }
  }]);
  return UnexpectedResponseError;
}(Phantom.Error);

exports.default = Phantom;